<?php

namespace Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Indexing;

class IndexRelations
{
    public const QUEUE_STATUS_IN_PROCESS = 'In Process';
    protected $db;

    static $eventTypeIds = array();

    public function __construct()
    {
        $this->db = \DBManagerFactory::getInstance();
    }

    public function addRelation(array $data)
    {
        $moduleName = $data['module_name'];
        $recordId = $data['record_id'];
        $eventTypeId = $data['event_type_id'];
        $linkName = $data['link_name'];

        $selectEventIds = "
            SELECT px_ntdv_relates_tree.id tree_id, px_ntdv_relates_tree.event_id
            FROM px_ntdv_relates_tree
            INNER JOIN px_needtodoevents ON
                px_needtodoevents.id = px_ntdv_relates_tree.event_id
            WHERE 
                px_needtodoevents.deleted = 0 AND
                px_needtodoevents.event_type_id = '$eventTypeId' AND
                px_ntdv_relates_tree.lhs_module='$moduleName' AND 
                px_ntdv_relates_tree.lhs_id = '$recordId' AND 
                px_ntdv_relates_tree.relate_link_name = '$linkName'
        ";

        $rs = $this->db->query($selectEventIds);
        while ($row = $this->db->fetchByAssoc($rs)) {
            $eventId = $row['event_id'];
            $this->pushRelationUpdateToQueue($eventId);
        }
    }


    public function removeRelation(array $data)
    {

        $moduleName = $data['module_name'];
        $recordId = $data['record_id'];
        $relatedModuleName = $data['related_module_name'];
        $relatedRecordId = $data['related_record_id'];
        $linkName = $data['link_name'];

        $selectRelatesTree = "
            SELECT distinct event_id
            FROM px_ntdv_relates_tree
            WHERE 
                (
                    (
                      lhs_module='$moduleName' AND lhs_id='$recordId' AND
                      rhs_module='$relatedModuleName' AND rhs_id='$relatedRecordId'
                    ) OR
                    (
                      lhs_module='$relatedModuleName' AND lhs_id='$relatedRecordId' AND
                      rhs_module='$moduleName' AND rhs_id='$recordId'
                    )
                ) AND relate_link_name = '$linkName'
                
        ";
        $rs = $this->db->query($selectRelatesTree);
        while ($row = $this->db->fetchByAssoc($rs)) {
            $this->pushRelationUpdateToQueue($row['event_id']);
        }
    }

    protected function pushRelationUpdateToQueue($eventId)
    {
        global $timedate;
        $db = \DBManagerFactory::getInstance();
        $currentDatetime = $timedate->nowDb();

        $queueIdSQL = "
                SELECT id 
                FROM px_ntdv_refresh_relations_queue 
                WHERE 
                    event_id='$eventId' AND 
                    (status IS NULL OR status = '' OR status <> '" . self::QUEUE_STATUS_IN_PROCESS . "')
            ";
        $row = $db->fetchOne($queueIdSQL);
        if (empty($row['id'])) {
            $indexStackId = \Sugarcrm\Sugarcrm\Util\Uuid::uuid1();
            $insertSQL = "
            INSERT INTO px_ntdv_refresh_relations_queue 
              (id, event_id, status, date_entered)
            VALUES 
              (
                '" . $indexStackId . "',
                '" . $eventId . "',
                '',
                '" . $currentDatetime . "'
              )
        ";
            $db->query($insertSQL);
        }

    }

}