<?php

require_once 'custom/PxRoutines/NeedToDoViewer/PX_NeedToDoEvents/visibility/NTDVSecurity.php';

class NTDVAssignSecurity implements NTDVSecurity{

    /**
     * @var PX_NeedToDoEvents
     */
    protected $ntdvEntity;

    public function __construct(PX_NeedToDoEvents $ntdvEntity){
        $this->ntdvEntity = $ntdvEntity;
    }

    public function applyParentSecurity(){
        if(empty($this->ntdvEntity->assigned_user_id)){
            $targetEntity = $this->ntdvEntity->getTargetEntityBean();
            if($this->validateTargetEntity($targetEntity)){
                $this->setAssignedUserId($targetEntity);
            }else{
                $this->ntdvEntity->assigned_user_id = '';
            }
        }
    }

    protected function validateTargetEntity($targetEntity){
        if(!empty($targetEntity) && $targetEntity instanceof SugarBean){
            if(isset($targetEntity->field_defs['assigned_user_id'])){
                return true;
            }
        }
        return false;
    }

    protected function setAssignedUserId($targetEntity){
        if(!empty($targetEntity->assigned_user_id)){
            $this->ntdvEntity->assigned_user_id = $targetEntity->assigned_user_id;
        }else{
            $this->ntdvEntity->assigned_user_id = '';
        }

    }

    protected function assign_display_fields(){

    }

}