<?php

class NTDVSecurityInheritance{

    /**
     * @var array
     */
    protected $securities = array();

    public function __construct(PX_NeedToDoEvents $ntdvEntity){
        $this->init($ntdvEntity);
    }

    protected function init(PX_NeedToDoEvents $ntdvEntity){
        $this->securities = array();
        if($ntdvEntity->field_defs['assigned_user_id']){
            require_once 'custom/PxRoutines/NeedToDoViewer/PX_NeedToDoEvents/visibility/NTDVAssignSecurity.php';
            $this->securities[] = new NTDVAssignSecurity($ntdvEntity);
        }
        if($ntdvEntity->field_defs['team_id']){
            require_once 'custom/PxRoutines/NeedToDoViewer/PX_NeedToDoEvents/visibility/NTDVTeamSecurity.php';
            $this->securities[] = new NTDVTeamSecurity($ntdvEntity);
        }
    }

    public function inherit(){
        foreach($this->securities as $security){
            $security->applyParentSecurity();
        }
    }

}