<?php

namespace Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\PX_NeedToDoViewerComments\Helpers;

/** TODO: name class as SUBSCRIPTION! */
class NeedToDoViewerCommentsUsers
{

    /**
     * @var \PX_NeedToDoViewerComments
     */
    private $commentBean;

    /**
     * @var ConversationParticipants
     */
    private $conversationParticipants;

    //TODO: remove this to participants
    private $users = [];


    public function __construct(\PX_NeedToDoViewerComments $commentBean)
    {
        $this->commentBean = $commentBean;
        $this->conversationParticipants = $this->commentBean->getConversationParticipants();
    }

    public function save(){
        if (!$this->commentBean->load_relationship('comments_users')) {
            return false;
        }

        $this->saveParticipantsForMainMessage();
    }

    private function saveParticipantsForMainMessage()
    {
        global $current_user;

        $subscribed = $this->conversationParticipants->getClippedSubscribedUsersId();
        $participants = $this->conversationParticipants->getClippedParticipantUsersId();
        $mentioned = $this->conversationParticipants->getClippedMentionedUsersIds();
        $authorId = $this->conversationParticipants->getMessageAuthorId();

        foreach ($participants as $userId) {
            $this->addUserToConversation($userId, 'new');
        }

        foreach ($mentioned as $userId) {
            $this->addUserToConversation($userId, 'new', 'mentioned');
        }

        foreach ($subscribed as $userId) {
            $this->addUserToConversation($userId, 'new', 'subscribed');
        }

        $this->addUserToConversation($authorId, 'read', 'author');
    }

    private function addUserToConversation($userId, $state = 'new', $type = 'participant')
    {
        if (isset($this->users[$userId])) {
            $user = $this->users[$userId];
        } else {
            $user = $this->users[$userId] = \BeanFactory::getBean('Users', $userId, array('strict_retrieve' => true));
        }

        if (!empty($user)) {
            global $timedate;
            $needToDoViewerBean = $this->conversationParticipants->getNeedToDoEventBean();
            $contextBean = $this->conversationParticipants->getContextBean();
            $mainMessageBean = $this->conversationParticipants->getMainMessageBean();

            if ($needToDoViewerBean->checkUserAccess($user) && (empty($contextBean) || empty($contextBean->id) || $contextBean->checkUserAccess($user))) {
                $additionalValues = array(
                    'parent_id' => $mainMessageBean->id,
                    'state' => $state,
                    'type' => $type,
                    'date_change_state' => $timedate->nowDb()
                );
                $this->commentBean->comments_users->add($user, $additionalValues);
            }
        }
        return true;
    }

}