<?php

namespace Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\PX_NeedToDoViewerComments\Helpers\Notification\Events;

use \Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\PX_NeedToDoViewerComments\Helpers\Notification\Entities\Comment;

abstract class Event{

    protected $langKey = '';
    protected $eventPriority = 0;
    protected $recipientIds = [];

    /**
     * @var Comment;
     */
    protected $commentEntity;

	public function __construct(Comment $commentEntity){
        $this->commentEntity = $commentEntity;
	}

	public function init(){
		$this->defineRecipientIds();
	}

	abstract public function defineRecipientIds();

	public function getRecipientIds(){
		return $this->recipientIds;
	}

	public function getPriority(){
		return $this->eventPriority;
	}

    public function getLangKey(){
        return $this->langKey;
    }

    public function getData(){
        return [
            'CREATED_BY' => $this->commentEntity->getCreatedUser(),
            'COMMENT_TEXT' => $this->commentEntity->getMessageText(),
            'DATE_ENTERED' => $this->commentEntity->getCreatedDate(),
            'NEED_TO_DO_EVENT_BEAN' => $this->commentEntity->getNeedToDoEventBean(),
            'CONTEXT_BEAN' => $this->commentEntity->getContextBean(),
        ];
    }

}