<?php

namespace Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\PX_NeedToDoViewerComments\Helpers\Notification\MessageComposer;

class MessageTemplate
{
    public $templates = array();
    protected $key = '';

    public const LABEL_PREFIX = 'MSG_NOTIFICATION_';
    public const TITLE_SUFFIX = '_TITLE';
    public const BODY_SUFFIX = '_BODY';

    public function __construct()
    {

    }

    public function getTitleTemplate(\User $user, $templateKey)
    {
        $titleTemplateKey = self::LABEL_PREFIX . $templateKey . self::TITLE_SUFFIX;
        $tpls = $this->getTemplateList($user);
        if (!empty($tpls[$titleTemplateKey])) {
            return $tpls[$titleTemplateKey];
        }
        return '';
    }

    public function getBodyTemplate(\User $user, $templateKey)
    {
        $bodyTemplateKey = self::LABEL_PREFIX . $templateKey . self::BODY_SUFFIX;
        $tpls = $this->getTemplateList($user);
        if (!empty($tpls[$bodyTemplateKey])) {
            return $tpls[$bodyTemplateKey];
        }
        return '';
    }

    public function getTemplateList(\User $user)
    {
        if (!isset($this->templates[$user->preferred_language])) {
            $this->templates[$user->preferred_language] = $this->loadTemplates($user->preferred_language);
        }
        return $this->templates[$user->preferred_language];
    }

    protected function loadTemplates($preferencedLanguage)
    {
        $languageList = $this->getLanguageList($preferencedLanguage);
        $templateList = [];
        foreach ($languageList as $language) {
            $templates = [];
            $languageFile = "custom/PxRoutines/NeedToDoViewer/PX_NeedToDoViewerComments/Helpers/Notification/MessageComposer/language/$language.templates.php";
            foreach (\SugarAutoLoader::existing($languageFile) as $file) {
                include $file;
            }
            $templateList = \sugarLangArrayMerge($templateList, $templates);
        }
        return $templateList;
    }

    protected function getLanguageList($preferencedLanguage)
    {
        global $sugar_config;
        $defaultLanguage = !empty($sugar_config['default_language']) ? $sugar_config['default_language'] : $preferencedLanguage;
        $languageList = array();
        if ($preferencedLanguage != 'en_us') {
            $languageList[] = 'en_us';
        }
        if ($defaultLanguage != 'en_us' && $preferencedLanguage != $defaultLanguage) {
            $languageList[] = $defaultLanguage;
        }
        $languageList[] = $preferencedLanguage;
        return $languageList;
    }

}