<?php

namespace Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Package;

class Package
{

    public const SUGAR_OUTFITTERS_LICENSE_TYPE = 'SUGAR_OUTFITTERS';
    public const NATIVE_LICENSE_TYPE = 'NATIVE';

    public function getPackageLicenseType()
    {
        $config = [];
        include 'custom/PxRoutines/NeedToDoViewer/Package/Config/config_params.php';
        $licenceType = !empty($config['license_type']) ? $config['license_type'] : '';
        return $licenceType == self::SUGAR_OUTFITTERS_LICENSE_TYPE ? self::SUGAR_OUTFITTERS_LICENSE_TYPE : self::NATIVE_LICENSE_TYPE;
    }

    public function getPackageVersion()
    {
        require_once 'modules/Administration/UpgradeHistory.php';
        $upgradeHistory = new \UpgradeHistory();
        $query = new \SugarQuery();
        $query->from($upgradeHistory);
        $query->where()->equals('id_name', 'integros_need_to_do_viewer');
        $query->where()->equals('status', 'installed');
        $query->where()->equals('enabled', '1');
        $query->orderBy('date_entered', 'DESC');
        $query->select(array('version'));
        $installedPackages = $query->execute();
        if (!empty($installedPackages)) {
            $installedPackage = $installedPackages[0];
            return $installedPackage['version'];
        }

        return '';
    }

    public function validateLicense($licenseData)
    {
        require_once 'custom/PxRoutines/NeedToDoViewer/Package/License/Control.php';
        $licenseControl = new \Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Package\License\Control();
        $licenseControl->setLicenseToken($licenseData);
        return $licenseControl->checkLicense();
    }

    public function setPackageInstallationDate()
    {
        require_once 'custom/PxRoutines/NeedToDoViewer/Package/License/Config.php';
        $pluginConfig = new \Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Package\License\Config();
        if (!$pluginConfig->packageInstallationDateExists()) {
            $pluginConfig->fixPluginInstallationDate();
        }
    }

    public function setDemoLicenseToken()
    {
        require_once 'custom/PxRoutines/NeedToDoViewer/Package/License/Config.php';
        $pluginConfig = new \Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\Package\License\Config();
        if (!$pluginConfig->licenseTokenExists()) {
            $pluginConfig->saveDemoLicenseToken();
        }
    }

}