<?php
 if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

$dictionary['px_needtodoviewercomments_users'] = array(
    'table' => 'px_needtodoviewercomments_users',
    'fields' => array(
        'id' => array(
            'name' => 'id',
            'type' => 'id',
            'len' => 36,
            'required' => true,
        ),
        'comment_id' => array(
            'name' => 'comment_id',
            'type' => 'id',
            'len' => 36,
            'required' => true,
        ),
        'user_id' => array(
            'name' => 'user_id',
            'type' => 'id',
            'len' => 36,
            'required' => true,
        ),
        'parent_id' => array(
            'name' => 'parent_id',
            'type' => 'id',
            'len' => 36,
            'required' => true,
        ),
        'state' => array(
            'name' => 'state',
            'type' => 'enum',
            'options' => 'px_timelinecomments_users_state_dom',
            'len' => '10',
        ),
        'date_change_state' => array(
            'name' => 'date_change_state',
            'type' => 'datetime',
        ),
        'type' => array(
            'name' => 'type',
            'type' => 'enum',
            'options' => 'px_timelinecomments_users_type_dom',
            'len' => '20',
        ),
        'date_entered' => array(
            'name' => 'date_entered',
            'type' => 'datetime',
        ),
        'date_modified' => array(
            'name' => 'date_modified',
            'type' => 'datetime',
        ),

        //TODO: Remove somehow
        'deleted' => array(
            'name' => 'deleted',
            'type' => 'bool',
            'default' => '0',
        ),
    ),
    'indices' => array(
        array(
            'name' => 'px_needtodoviewercomments_users_pk',
            'type' => 'primary',
            'fields' => array('id'),
        ),
    ),
    'relationships' => array(
        'px_needtodo_comments_users' => array(
            'lhs_module' => 'PX_NeedToDoViewerComments',
            'lhs_table' => 'px_needtodoviewercomments',
            'lhs_key' => 'id',
            'rhs_module' => 'Users',
            'rhs_table' => 'users',
            'rhs_key' => 'id',
            'relationship_type' => 'many-to-many',
            'join_table' => 'px_needtodoviewercomments_users',
            'join_key_lhs' => 'comment_id',
            'join_key_rhs' => 'user_id',
            'relationship_file' => 'custom/PxRoutines/NeedToDoViewer/PX_NeedToDoViewerComments/Data/Relationships/NTDVCommentsUsersM2MRelationship.php',
            'relationship_class' => 'NTDVCommentsUsersM2MRelationship',
        ),
        'px_needtodo_dialog_users' => array(
            'lhs_module' => 'PX_NeedToDoViewerComments',
            'lhs_table' => 'px_needtodoviewercomments',
            'lhs_key' => 'id',
            'rhs_module' => 'Users',
            'rhs_table' => 'users',
            'rhs_key' => 'id',
            'relationship_type' => 'many-to-many',
            'join_table' => 'px_needtodoviewercomments_users',
            'join_key_lhs' => 'parent_id',
            'join_key_rhs' => 'user_id',
            'relationship_file' => 'custom/PxRoutines/NeedToDoViewer/PX_NeedToDoViewerComments/Data/Relationships/NTDVCommentsUsersM2MRelationship.php',
            'relationship_class' => 'NTDVCommentsUsersM2MRelationship',
        )
    )
);
