<?php

require_once 'clients/base/api/FilterApi.php';

class PX_NeedToDoEventTypesFilterApi extends FilterApi
{
    public function addTargetFilters(array $filterDefs, SugarQuery_Builder_Where $where, SugarQuery $q)
    {
        $filterDefs = $this->transformAfterTodayFilters($filterDefs);
        try {
            static::addFilters($filterDefs, $where, $q);
        }catch(Exception $e){

        }
    }

    protected function transformAfterTodayFilters(array $filterDefs){
        global $timedate;
        $todayDate = $timedate->getNow(true);
        $sugarDatetimeStart = $todayDate->get_day_begin();
        $sugarDatetimeEnd = $todayDate->get_day_end();
        $dateStart = $timedate->asIso($sugarDatetimeStart);
        $dateEnd = $timedate->asIso($sugarDatetimeEnd);

        foreach($filterDefs as $key => $filterDef){
            foreach($filterDef as $fieldName => $filter){
                foreach($filter as $operator => $value) {
                    if ($operator == '$ntdv_before_today') {
                        unset($filterDefs[$key][$fieldName][$operator]);
                        $filterDefs[$key][$fieldName]['$lt'] = $dateStart;
                    }else if ($operator == '$ntdv_after_today') {
                        unset($filterDefs[$key][$fieldName][$operator]);
                        $filterDefs[$key][$fieldName]['$gt'] = $dateEnd;
                    }
                }
            }
        }

        return $filterDefs;
    }
}
