<?php
 if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once 'modules/PX_NeedToDoEvents/clients/base/api/PX_NeedToDoEventsApi.php';
use Sugarcrm\Sugarcrm\custom\PxRoutines\NeedToDoViewer\PX_NeedToDoEvents\helpers\NotifyUsersList;

class PX_NeedToDoEventsNotifyApi extends PX_NeedToDoEventsApi
{

    public function registerApiRest()
    {
        return array(
            'need_to_do_notify_list' => array(
                'reqType' => 'GET',
                'path' => array('pxntdv', 'notifications'),
                'pathVars' => array('', ''),
                'method' => 'getNeedToDoNotificationList',
                'shortHelp' => '',
                'longHelp' => '',
            ),
        );
    }

    public function getNeedToDoNotificationList(ServiceBase $api, array $args)
    {
        try {
            return $this->getNeedToDoEventsListForNotification($api, $args);
        } catch(Exception $e) {
            return [];
        }
    }

    protected function getNeedToDoEventsListForNotification($api, $args)
    {
        global $timedate, $current_user;

        $query = $this->getNeedToDoEventQueryObject($api, $args);

        $ntdvNotifyUsersTableAlias = "ntdv_notify_users_beforehand";
        $joinNtdvNotifyUsersSQL = "(SELECT id, event_id FROM px_ntdv_notify_users WHERE user_id = '" . $current_user->id . "' AND notified = " . NotifyUsersList::NOTIFICATION_ON_STATUS . ")";
        $query->join[$ntdvNotifyUsersTableAlias] = $query->joinTable($joinNtdvNotifyUsersSQL, array('alias' => $ntdvNotifyUsersTableAlias, 'joinType' => 'INNER'));
        $query->join[$ntdvNotifyUsersTableAlias]->on()->equalsField($ntdvNotifyUsersTableAlias . '.event_id', 'id');
        $query->select()->addField("$ntdvNotifyUsersTableAlias.id", array('alias' => 'ntdv_notify_users_id'));

        $toDatetime = $currentDatetimeStr = $timedate->nowDb();
        $query->where()->lte('notify_date', $toDatetime);

        $query->orderByReset();
        $query->orderBy('notify_date', 'DESC');
        $query->limit(1000);

        $result = $this->formatResult($api, $args, $query);

        $this->markEventNotificationsAsSent($result);
        return $result;
    }

    protected function markEventNotificationsAsSent($result)
    {
        if (empty($result['records']) || !is_array($result['records'])) {
            return;
        }

        $idsToMarkAsSent = [];
        foreach ($result['records'] as $record) {
            $idsToMarkAsSent[] = $record['ntdv_notify_users_id'];
        }

        if (!empty($idsToMarkAsSent)) {
            $db = \DBManagerFactory::getInstance();
            $sql = "UPDATE px_ntdv_notify_users SET notified=" . NotifyUsersList::NOTIFICATION_COMPLETED_STATUS . " WHERE id in ('" . implode("', '", $idsToMarkAsSent) . "')";
            $db->query($sql);
        }
    }

}
