({
    events: {
        'change div[data-placeholder]': 'checkPlaceholder',
        'keydown div[data-placeholder]': 'checkPlaceholder',
        'keypress div[data-placeholder]': 'checkPlaceholder',
        'input div[data-placeholder]': 'checkPlaceholder',
        'click .reply-btn': 'addComment',
    },

    //plugins: ['RelativeTime', 'FileDragoff', 'Taggable'],
    plugins: ['Taggable'],

    className: 'ntdv-create-comment',

    hideReplyArea: true,
    hasSubjectField: false,

    postButtonLabel: '',

    initialize: function(options) {
        if(!_.isUndefined(options.hideReplyArea))
            this.hideReplyArea = options.hideReplyArea;

        app.view.View.prototype.initialize.call(this, options);

        var module = this.model.get('module') || this.model.get('_module');
        if(module == 'PX_NeedToDoEvents') {
            this.postButtonLabel = app.lang.get('LBL_POST_BUTTON_LABEL', 'PX_NeedToDoViewerComments');
            this.hasSubjectField = true;
        }else {
            this.postButtonLabel = app.lang.get('LBL_REPLY_BUTTON_LABEL', 'PX_NeedToDoViewerComments');
        }

        this.setTaggableRecord(this.model.get('parent_type'), this.model.get('parent_id'));
    },

    checkPlaceholder: function(e) {
        var el = e.currentTarget;
        if (el.textContent) {

            // if($(el).hasClass('reply-subject-value') && e.keyCode && !_.isUndefined(e.key)) {
            //     //not shift,ctrl,alt
            //     if(!e.altKey && !e.ctrlKey && !e.shiftKey){
            //         //is not one of cursor movements
            //         var allowedKeyCodes = [
            //             /*BACKSPACE*/ 8, /*PageUp*/ 33, /*PageDown*/ 34,
            //             /* END */ 35, /* HOME */ 36, /* LEFT */ 37,
            //             /* UP */ 38, /* RIGHT */ 39, /* DOWN */ 40, /* DEL */ 46,
            //         ];
            //         if(_.indexOf(allowedKeyCodes, e.keyCode, true) == -1){
            //             var content = this.getCommentSubject();
            //             if(content.length >= 254)
            //                 e.preventDefault();
            //         }
            //     }
            // }

            el.setAttribute('data-hide-placeholder', 'true');
            this.toggleSubmitButton(this.canSubmitButtonBeToggled(el));

        } else {
            el.removeAttribute('data-hide-placeholder');
            this.toggleSubmitButton(false);
        }
    },

    // checkPasteEvent: function(e){
    //     var clipboardData, pastedData, currentDivContent, totalTextLength;
    //
    //     clipboardData = e.clipboardData || e.originalEvent.clipboardData || window.clipboardData;
    //     pastedData = clipboardData.getData('text');
    //     currentDivContent = this.getCommentSubject();
    //     totalTextLength = currentDivContent.length + pastedData.length;
    //
    //     if(totalTextLength >= 255){
    //         e.preventDefault();
    //     }
    // },

    canSubmitButtonBeToggled: function(el){
        var $subjectEl,
            $bodyEl,
            messageParentType = this.model.module || this.context.get('module');

        if($(el).hasClass('reply-subject-value')){
            $subjectEl = $(el);
            $bodyEl = $(el).closest('.reply-input').find('.reply-body-value');
        }else{
            $bodyEl = $(el);
            $subjectEl = $(el).closest('.reply-input').find('.reply-subject-value');
        }

        return (messageParentType != 'PX_NeedToDoEvents' || ($subjectEl.length && $subjectEl[0].textContent)) && $bodyEl.length && $bodyEl[0].textContent;
    },

    toggleSubmitButton: function(enable) {
        if (!enable) {
            this.disableSubmitButton();
        } else {
            this.enableSubmitButton();
        }
    },

    /**
     * Enable Submit button
     */
    enableSubmitButton: function() {
        this.$('.reply-btn')
            .removeClass('disabled')
            .attr('aria-disabled', false)
            .attr('tabindex', 0);
    },

    /**
     * Disable Submit button
     */
    disableSubmitButton: function() {
        this.$('.reply-btn')
            .addClass('disabled')
            .attr('aria-disabled', true)
            .attr('tabindex', -1);
    },

    toggleReplyBar: function(isHidden) {
        // if(this.hideReplyArea){
        //     //this.$('.reply-area').toggleClass('hide', !isHidden);
        //     this.$el.find('.reply-area:first').toggleClass('hide', !isHidden);
        // }

        var replyEl =  this.$el.find('.reply-area');
        if(isHidden){
            replyEl.show().css('display', 'block').removeClass('hide');
        }else{
            replyEl.hide().css('display', 'none').addClass('hide');
        }
    },

    animateToggleReplyBar: function(isHidden, callback) {
        this.hideReplyArea = isHidden;
        var replyEl =  this.$el.find('.reply-area');
        replyEl
            .animate({
                    height: "toggle"
                }, 100,
                _.bind(callback, this));
    },

    isReplyBarHidden: function(){
        return  this.$el.find('.reply-area:first').hasClass('hide');
        //return this.$('.reply-area').hasClass('hide');
    },

    // addCommentButtonClick: function(){
    //     var el = e.currentTarget;
    //     this.addComment(el);
    // },
    //
    // addComment: function (el) {
    //     var self = this,
    addComment: function (e) {
        var el = e.currentTarget,
            self = this,
            parentType = this.model.module || this.context.get('module'),
            parentId = this.model.id,
            payload = {
                parent_type: parentType,
                parent_id: parentId,
                data: {},
                name: ''
            },
            bean;

        payload.name = this.getCommentSubject();
        payload.data = this.getComment();

        if ((parentType == 'PX_NeedToDoViewerComments' || (payload.name && (payload.name.length > 0))) && payload.data.value && (payload.data.value.length > 0)) {

            bean = app.data.createBean('PX_NeedToDoViewerComments');
            bean.save(payload, {
                success: _.bind(self.addCommentCallback, self, el),
                complete: function() {},
                showAlerts: false
            });
        }
    },

    getCommentSubject: function() {
        return this.unformatTags(this.$('div.reply-subject-value')).value;
    },

    getComment: function() {
        return this.unformatTags(this.$('div.reply-body-value'));
    },

    addCommentCallback: function (el, model) {
        $(el).closest('.reply-input').find('div.reply-subject-value').empty().trigger('change');
        $(el).closest('.reply-input').find('div.reply-body-value').empty().trigger('change');

        this.layout.addCommentCallback(el, model);

        this.context.trigger('list:paginate:hide');
        if(model.get('parent_type') == 'PX_NeedToDoEvents')
            this.context.trigger('subpanel:comments:add');
    }

})
