({
    events: {},

    plugins: ['RelativeTime', 'FileDragoff' /*, 'Taggable'*/],

    className: 'ntdv-comments-list',

    commentsCollection: null,
    commentReplyView: null,

    inlineFetch: false,
    hideReplyArea: true,
    hideCommentsButton: false,

    isReply: false,
    commentsNestingLevel: 0,

    commentsAreFetched: false,
    showMoreLabelTpl: '',
    hideLabelTpl: '',

    //commentViewBuffer: {},
    openedCommentIds: [],
    expandReplies: false,

    needToDoEventLayout: null,

    initialize: function(options) {

        if(!_.isUndefined(options.inlineFetch))
            this.inlineFetch = options.inlineFetch;
        if(!_.isUndefined(options.hideReplyArea))
            this.hideReplyArea = options.hideReplyArea;
        if(!_.isUndefined(options.isReply))
            this.isReply = options.isReply;
        if(!_.isUndefined(options.commentsNestingLevel))
            this.commentsNestingLevel = options.commentsNestingLevel - 1;
        if(!_.isUndefined(options.expandReplies))
            this.expandReplies = options.expandReplies;
        if(!_.isUndefined(options.needToDoEventLayout))
            this.needToDoEventLayout = options.needToDoEventLayout;


        app.view.View.prototype.initialize.call(this, options);

        if(this.model.get('parent_type') == 'PX_NeedToDoViewerComments'){
            this.isReply = true;
        }

        this.events['click .more[data-idAction="' + this.cid + '"]'] = 'showComments';
        this.events['click .less[data-idAction="' + this.cid + '"]'] = 'hideComments';

        //this.events['click .less'] = 'hideComments2';

        this.initCommentsCollection();
        this.initCommentsAmount();

        this.initCommentReplyView();
    },

    initCommentsCollection: function(){
        // var lastComment = this.model.get("last_comment");
        this.commentsCollection = app.data.createRelatedCollection(this.model, "comments");

        // if (!this.isReply && lastComment && !_.isUndefined(lastComment.id)) {
        //     this.commentsCollection.reset([lastComment]);
        // }
        this.model.set("comments", this.commentsCollection);
    },

    initCommentsAmount: function(){
        if(this.isReply){
            this.initRepliesAmount();
            return;
        }

        // var count = parseInt(this.model.get('comment_count'), 10);
        var count = this.remaining_comments = parseInt(this.model.get('comment_count'), 10);
        // this.remaining_comments = 0;
        // this.showMoreLabelTpl = "TPL_MORE_COMMENT";
        // this.hideLabelTpl = 'TPL_HIDE_COMMENT';
        //
        // if (count) {
        //     this.remaining_comments = count; // - 1;
        //     if (count > 2) {
        //         this.showMoreLabelTpl = "TPL_MORE_COMMENTS";
        //         this.hideLabelTpl = 'TPL_HIDE_COMMENTS';
        //     }
        // }
        if(this.remaining_comments && (this.inlineFetch || this.expandReplies)){
            this.fetchComments();
        }
    },

    initRepliesAmount: function(){
        var count = this.remaining_comments = parseInt(this.model.get('comment_count'), 10);
        this.showMoreLabelTpl = "TPL_SHOW_REPLY";
        this.hideLabelTpl = 'TPL_HIDE_REPLY';
        if (count >= 2) {
            this.showMoreLabelTpl = "TPL_SHOW_REPLIES";
            this.hideLabelTpl = 'TPL_HIDE_REPLIES';
        }
        if(count && (this.inlineFetch || this.expandReplies)){
            this.fetchComments();
        }
    },

    addCommentCallback: function (el, model) {
        this.commentsCollection.add(model);
        var $button = $(el).closest('.ntdv-comment-item').find('.comment-btn').first();
        if(!this.isReply){
            $button = $(el).closest('.ntdv-comment-container').prev().find('.comment-btn').first();
        }
        // this.toggleReplyBar($button[0]);

        var template = app.view.createView({
            context: this.context,
            name: "need-to-do-event-comment",
            type: "need-to-do-event-comment",
            module: this.module,
            layout: this,
            model: model,
            inlineFetch: this.inlineFetch,
            isReply: true, //this.isReply,
            commentsNestingLevel: this.commentsNestingLevel,
            needToDoEventLayout: this.needToDoEventLayout,
        });
        $(el).closest('.need-to-do-event-comments').find('.comments-list').first().prepend(template.$el);
        template.render();

        if(this.layout.$('.ntdv-panel').length) {
            this.layout.$('.ntdv-panel .show-comments-btn:not(.empty-conversation-list)').show();
            this.layout.$('.ntdv-panel .show-comments-btn.empty-conversation-list').hide();
        }
    },

    toggleReplyBar: function(el) {
        if(this.hideReplyArea){
            var isHidden = this.commentReplyView.isReplyBarHidden();

            $(el).toggleClass('active', isHidden)
                .attr('aria-pressed', isHidden);
            this.commentReplyView.toggleReplyBar(isHidden);
        }
    },

    fetchComments: function() {
        var self = this;
        this.commentsAreFetched = true;
        this.commentsCollection.fetch({
            //Don't show alerts for this request
            showAlerts: false,
            relate: true,
            max_num: -1,
            success: function(collection) {
                // self.hideCommentsButton = true;
                self.hideCommentsButton = false;
                self.renderCommentsList();
            }
        });
    },

    showComments: function(e){
        this.hideCommentsButton = true;
        var el = e.currentTarget,
            moreEl = $(el).parent(),
            lessEl = moreEl.next(),
            commentListEl = moreEl.prev();

        if(!this.commentsAreFetched){
            this.fetchComments();
        }else {
            this.hideCommentItemss(commentListEl, false);
            //commentListEl.show();
        }
        lessEl.show();
        moreEl.hide();
        this.openedCommentIds.push(this.model.id);
    },

    hideComments: function(e) {
        var el = e.currentTarget,
            lessEl = $(el).parent(),
            moreEl = lessEl.prev(),
            commentListEl = moreEl.prev();
        this.hideCommentsButton = false;

        //commentListEl.hide();
        this.hideCommentItemss(commentListEl, true);
        lessEl.hide();
        moreEl.show();
    },


    showNeedToDoEventComments: function(commentListEl){
        this.hideCommentsButton = true;

        if(!this.commentsAreFetched){
            this.fetchComments();
        }else {
            this.hideCommentItemss(commentListEl, false);
        }
        this.openedCommentIds.push(this.model.id);
    },

    slideShowNeedToDoEventComments: function(commentListEl, callback){
        this.hideCommentsButton = true;

        if(!this.commentsAreFetched){
            this.fetchComments(this.animateToggleCommentItemss(commentListEl, this.commentReplyView.animateToggleReplyBar(true, callback)));
            commentListEl.addClass('expanded');
        }else {
            this.animateToggleCommentItemss(commentListEl, this.commentReplyView.animateToggleReplyBar(true, callback));
        }

        this.openedCommentIds.push(this.model.id);
    },

    hideNeedToDoEventComments: function(commentListEl) {
        // this.hideCommentsButton = false;
        // this.hideCommentItemss(commentListEl, true);

        this.hideCommentsButton = false;
        commentListEl.hide();
        this.commentReplyView.hideReplyArea = false;
        this.commentReplyView.toggleReplyBar(false);

        commentListEl.removeClass('expanded');
    },

    slideHideNeedToDoEventComments: function(commentListEl, callback) {
        this.hideCommentsButton = false;
        this.animateToggleCommentItemss(commentListEl, this.commentReplyView.animateToggleReplyBar(false, callback));
        commentListEl.removeClass('expanded');
    },

    animateToggleCommentItemss: function(commentsList, callback){
        commentsList.toggleClass('expanded');
        commentsList
            .animate({
                    height: "toggle"
                }, 100,
                callback
            );
    },

    //hideComments2: function(e) {
    //
    //    var el = e.currentTarget;
    //
    //
    //},

    hideCommentItemss: function(commentsList, hide){
        if(hide){
            $(commentsList).removeClass('expanded');
        }else{
            $(commentsList).addClass('expanded');
        }

        _.each($(commentsList).children('.ntdv-comment-item'), function(el, key){
            // if(key || this.isReply){
            if(key >= 0 || this.isReply){
                if(hide) {
                    $(el).hide();
                }else {
                    $(el).show();
                }
            }
        }, this);
    },

    _renderHtml: function(model) {
        //var isReplyBarOpen = this.$(".comment-btn").hasClass("active") && this.$(".comment-btn").is(":visible"),
        //    replyVal = this.$(".reply").html();
        app.view.View.prototype._renderHtml.call(this);



        // _.each(this.commentsCollection.models, function(model){
        //     var expand = this.isRepliesExpanded(model);
        //     this.renderCommentView(model, expand);
        // }, this);

        this.renderCommentsList();

        this.renderCommentReplyView();

        //if (isReplyBarOpen) {
        //    this.toggleReplyBar();
        //    this.$(".reply").html(replyVal);
        //}
    },

    renderCommentsList: function(){
        _.each(this.commentsCollection.models, function(model){
            var expand = this.isRepliesExpanded(model);
            this.renderCommentView(model, expand);
        }, this);
    },

    bindDataChange: function() {
        if (this.commentsCollection) {
            this.commentsCollection.on("add", function (model) {
                this.model.set('comment_count', this.model.get('comment_count') + 1);
            }, this);
        }
        app.view.View.prototype.bindDataChange.call(this);
    },

    initCommentReplyView: function(){
        this.commentReplyView = app.view.createView({
            context: this.context,
            name: "need-to-do-create-comment",
            type: "need-to-do-create-comment",
            module: this.module,
            layout: this,
            model: this.model,
            hideReplyArea: this.hideReplyArea,
            isReply: this.isReply,
            commentsNestingLevel: this.commentsNestingLevel,
        });
        //this.$el.find('.comment-create-form:first').append(this.commentReplyView.$el);
        //this.commentReplyView.render();
    },

    renderCommentReplyView: function(){
        if(this.commentsNestingLevel >= 0) {
            this.$el.find('.comment-create-form:first').append(this.commentReplyView.$el);
            this.commentReplyView.render();
        }
    },

    isRepliesExpanded: function(model){
        return _.indexOf(this.openedCommentIds, model.get('id')) > -1;
    },

    renderCommentView: function(model, expand){
        var isUnreadMessage = this.isUnreadMessage(model),
            view = app.view.createView({
            context: this.context,
            name: "need-to-do-event-comment",
            type: "need-to-do-event-comment",
            module: this.module,
            layout: this,
            model: model,
            inlineFetch: this.inlineFetch,
            isReply: true, //this.isReply,
            commentsNestingLevel: this.commentsNestingLevel,
            expandReplies: expand,
            isUnreadMessage: isUnreadMessage,
            needToDoEventLayout: this.needToDoEventLayout
        });
        this.$el.find('.comments-list:first').append(view.$el);
        view.render();
        //this.commentViewBuffer[model.get('id')] = view;
    },

    isUnreadMessage: function(reply){
        var mewMessages = this.model.get('unread_comment_ids'),
            replyId = reply.get('id');
        if(!_.isEmpty(mewMessages) && _.find(mewMessages, function(newMessage){ return newMessage == replyId; })){
            return true;
        }
        return false;
    },

    unbindData: function() {
        if (this.commentsCollection) {
            this.commentsCollection.off();
        }
        app.view.View.prototype.unbindData.call(this);
    },

    _dispose: function() {
        $(window).off('resize.' + this.cid);
        app.view.View.prototype._dispose.call(this);
        this.commentsCollection = null;
    },

})
